Index: libroarpulse/channelmap.c
===================================================================
--- libroarpulse/channelmap.c	(revision 3456)
+++ libroarpulse/channelmap.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/context.c
===================================================================
--- libroarpulse/context.c	(revision 3438)
+++ libroarpulse/context.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/error.c
===================================================================
--- libroarpulse/error.c	(revision 3444)
+++ libroarpulse/error.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/introspect.c
===================================================================
--- libroarpulse/introspect.c	(revision 3420)
+++ libroarpulse/introspect.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/libroarpulse.c
===================================================================
--- libroarpulse/libroarpulse.c	(revision 3408)
+++ libroarpulse/libroarpulse.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/libroarpulseinfo.c
===================================================================
--- libroarpulse/libroarpulseinfo.c	(revision 706)
+++ libroarpulse/libroarpulseinfo.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/mainloop-signal.c
===================================================================
--- libroarpulse/mainloop-signal.c	(revision 3496)
+++ libroarpulse/mainloop-signal.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/mainloop.c
===================================================================
--- libroarpulse/mainloop.c	(revision 3493)
+++ libroarpulse/mainloop.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/operation.c
===================================================================
--- libroarpulse/operation.c	(revision 3400)
+++ libroarpulse/operation.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/sample.c
===================================================================
--- libroarpulse/sample.c	(revision 3421)
+++ libroarpulse/sample.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/simple.c
===================================================================
--- libroarpulse/simple.c	(revision 3389)
+++ libroarpulse/simple.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/stream.c
===================================================================
--- libroarpulse/stream.c	(revision 3514)
+++ libroarpulse/stream.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/timeval.c
===================================================================
--- libroarpulse/timeval.c	(revision 3448)
+++ libroarpulse/timeval.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/utf8.c
===================================================================
--- libroarpulse/utf8.c	(revision 3478)
+++ libroarpulse/utf8.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/util.c
===================================================================
--- libroarpulse/util.c	(revision 3515)
+++ libroarpulse/util.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/version.c
===================================================================
--- libroarpulse/version.c	(revision 3395)
+++ libroarpulse/version.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/volume.c
===================================================================
--- libroarpulse/volume.c	(revision 3459)
+++ libroarpulse/volume.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/x11.c
===================================================================
--- libroarpulse/x11.c	(revision 3491)
+++ libroarpulse/x11.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches:
Index: libroarpulse/xmalloc.c
===================================================================
--- libroarpulse/xmalloc.c	(revision 3394)
+++ libroarpulse/xmalloc.c	(revision 3517)
@@ -23,5 +23,6 @@
  *  You should have received a copy of the GNU General Public License
  *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
+ *  Boston, MA 02110-1301, USA.
  *
  *  NOTE for everyone want's to change something and send patches: