Index: roarclients/pgptest.c
===================================================================
--- roarclients/pgptest.c	(revision 4708)
+++ roarclients/pgptest.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/pinentrytest.c
===================================================================
--- roarclients/pinentrytest.c	(revision 4708)
+++ roarclients/pinentrytest.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/pipetest.c
===================================================================
--- roarclients/pipetest.c	(revision 4914)
+++ roarclients/pipetest.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/polytest.c
===================================================================
--- roarclients/polytest.c	(revision 4708)
+++ roarclients/polytest.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roar-config.c
===================================================================
--- roarclients/roar-config.c	(revision 4885)
+++ roarclients/roar-config.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarbidir.c
===================================================================
--- roarclients/roarbidir.c	(revision 5022)
+++ roarclients/roarbidir.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcat.c
===================================================================
--- roarclients/roarcat.c	(revision 5349)
+++ roarclients/roarcat.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcat2sock.c
===================================================================
--- roarclients/roarcat2sock.c	(revision 5109)
+++ roarclients/roarcat2sock.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcatad.c
===================================================================
--- roarclients/roarcatad.c	(revision 5238)
+++ roarclients/roarcatad.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcatpassfh.c
===================================================================
--- roarclients/roarcatpassfh.c	(revision 5238)
+++ roarclients/roarcatpassfh.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcatplay.c
===================================================================
--- roarclients/roarcatplay.c	(revision 5221)
+++ roarclients/roarcatplay.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcatsendfile.c
===================================================================
--- roarclients/roarcatsendfile.c	(revision 5109)
+++ roarclients/roarcatsendfile.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcatvio.c
===================================================================
--- roarclients/roarcatvio.c	(revision 5022)
+++ roarclients/roarcatvio.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarclientpass.c
===================================================================
--- roarclients/roarclientpass.c	(revision 4948)
+++ roarclients/roarclientpass.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2010-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarctl.c
===================================================================
--- roarclients/roarctl.c	(revision 5379)
+++ roarclients/roarctl.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roardtmf.c
===================================================================
--- roarclients/roardtmf.c	(revision 5249)
+++ roarclients/roardtmf.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarfctest.c
===================================================================
--- roarclients/roarfctest.c	(revision 4708)
+++ roarclients/roarfctest.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarfilt.c
===================================================================
--- roarclients/roarfilt.c	(revision 5289)
+++ roarclients/roarfilt.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarinterconnect.c
===================================================================
--- roarclients/roarinterconnect.c	(revision 5380)
+++ roarclients/roarinterconnect.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarlight.c
===================================================================
--- roarclients/roarlight.c	(revision 5289)
+++ roarclients/roarlight.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarmon.c
===================================================================
--- roarclients/roarmon.c	(revision 5238)
+++ roarclients/roarmon.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarmonhttp.c
===================================================================
--- roarclients/roarmonhttp.c	(revision 5300)
+++ roarclients/roarmonhttp.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarphone.c
===================================================================
--- roarclients/roarphone.c	(revision 5380)
+++ roarclients/roarphone.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarpluginrunner.c
===================================================================
--- roarclients/roarpluginrunner.c	(revision 5362)
+++ roarclients/roarpluginrunner.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2011-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarradio.c
===================================================================
--- roarclients/roarradio.c	(revision 5375)
+++ roarclients/roarradio.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarshout.c
===================================================================
--- roarclients/roarshout.c	(revision 5179)
+++ roarclients/roarshout.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarsin.c
===================================================================
--- roarclients/roarsin.c	(revision 5249)
+++ roarclients/roarsin.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarsockconnect.c
===================================================================
--- roarclients/roarsockconnect.c	(revision 5375)
+++ roarclients/roarsockconnect.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarsocktypes.c
===================================================================
--- roarclients/roarsocktypes.c	(revision 5109)
+++ roarclients/roarsocktypes.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roartypes.c
===================================================================
--- roarclients/roartypes.c	(revision 5328)
+++ roarclients/roartypes.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarvio.c
===================================================================
--- roarclients/roarvio.c	(revision 5109)
+++ roarclients/roarvio.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2011-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarvorbis.c
===================================================================
--- roarclients/roarvorbis.c	(revision 5249)
+++ roarclients/roarvorbis.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarvumeter.c
===================================================================
--- roarclients/roarvumeter.c	(revision 5289)
+++ roarclients/roarvumeter.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/zcattest.c
===================================================================
--- roarclients/zcattest.c	(revision 4708)
+++ roarclients/zcattest.c	(revision 5381)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2011
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2012
  *
  *  This file is part of roarclients a part of RoarAudio,